<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<!-- Bootstrap CSS -->
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
	<title>Bootstrap Flex</title>
</head>
<body>
	<h1 class="text-center my-5">Bootstrap Flex</h1>
	<!-- 
		Flexbox is used to manipulate and layout our elements. This can be done exclusively in CSS. However, using Bootstrap, it is mch easier and faster to implement flex becaause all we have to do is to add the class "d-flex" to the parent of our flex items.

		Flex items, flex children, when adding d-flex to their parent, the items are in a row. We can adjust the height and width not like your inline elements.

		Flex Directions:

		You can change the direction of your flex items by adding flex-direction. However, by default, flex-row is the arrangement of your flex items.

		Flex Row Reverse
		Starts our items from the opposite side (right) and reverses the order of our flex items.

		flex-row starts from left to right. (default)
		flex-row-reverse starts from right to left

		Flex Column
		Flex Column will arrange our items from top to bottom and by default the flex items will occupy the width of its parent.

		Flex Column Reverse
		Does the same as flex-column jsut that it starts from the bottom to the top.
	 -->
	<h3 class="text-center">Flex Row</h3>
	<div class="bg-dark d-flex flex-row mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div class="bg-dark d-flex flex-row mb-4">
		<span class="bg-primary p-2">Span Flex 1</span>
		<span class="bg-danger p-2">Span Flex 2</span>
		<span class="bg-success p-2">Span Flex 3</span>
	</div>

	<h3 class="text-center my-5">Flex Row Reverse</h3>
	<div class="d-flex flex-row-reverse bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Flex Column</h3>
	<div class="d-flex flex-column bg-dark mb-4 p-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div class="bg-dark d-flex flex-column mb-4 p-4">
		<span class="bg-primary p-2">Span Flex 1</span>
		<span class="bg-danger p-2">Span Flex 2</span>
		<span class="bg-success p-2">Span Flex 3</span>
	</div>

	<h3 class="text-center my-5">Flex Column Reverse</h3>
	<div class="bg-dark d-flex flex-column-reverse mb-4 p-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<!-- Justify Content -->
	<h2 class="text-center my-5">Justify Content</h2>
	<!-- justify-content allows us to manipulate and change the alignment of our flex along our main axis. THe main axis for flex-row items is our x-axis. justify content allows us to horizontally align our flex row items. -->
	<h3 class="text-center my-5">Justify Content Start</h3>
	<!-- justify-content-start the default value of justify-content for flex items. It allows us to align our flex items to the start of their main axis. For flex-row, it starts from the left, for flex-row-reverse, it starts from the right. -->
	<div class="bg-dark d-flex flex-row justify-content-start mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div class="bg-dark d-flex flex-row-reverse justify-content-start mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<h3 class="text-center my-5">Justify Content End</h3>
	<!-- Aligns our flex items where our main axis ends. For flex row, the end from the right, for flex-row-reverse,  -->
	<div class="bg-dark d-flex flex-row justify-content-end mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="bg-dark d-flex flex-row-reverse justify-content-end mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<h3 class="text-center my-5">Justify Content Center</h3>
	<!-- Aligns our flex items at the center of the main axis. The main axis for both flex-row and flex-row-reverse is the x-axis. Therefore, with justify-content-center, we can cener our items horizontally. -->
	<div class="bg-dark d-flex flex-row justify-content-center mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div class="bg-dark d-flex flex-row-reverse justify-content-center mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Justify Content Between</h3>
	<!-- justify-content-between adds/distributes remaining spaces in between our items. -->
	<div class="d-flex flex-row justify-content-between bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-warning p-2">Flex Item 4</div>
		<div class="bg-info p-2">Flex Item 5</div>
	</div>

	<div class="d-flex flex-row-reverse justify-content-between bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Justify Content Around</h3>
	<!-- Aligns our items by distributing around your items. Meaning It will automatically calculate the space remaining and add that space around your items. -->
	<div class="bg-dark d-flex flex-row justify-content-around mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div class="bg-dark d-flex flex-row-reverse justify-content-around mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<!-- Align Items -->
	<h2 class="text-center">Align Items</h2>
	<!-- align-items - aligns your items vertically for flex-row and flex-row-reverse -->
	<h3 class="text-center">Align Items Start</h3>
	<!-- 
		align-items-start - aligns items at the start of the y-axis or cross-axis for flex-row and flex-row-reverse. 

		For flex-row and flex-row-reverse, the y-axis is the cross axis, and the x-axis is their main axis.

		For flex-column, and flex-column-reverse, the y-axis is the main axis, and the x-axis is their cross axis.

		For flex-row and flex-row-reverse, the start of their y-axis is at the top.

	-->
	<div class="d-flex flex-row align-items-start bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div class="d-flex flex-row-reverse align-items-start bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Align Items End</h3>
	<!-- Align items end will align our flex-row and flex-row-reverse items at the end of their cross-acis, which is the y-axis, meaning they will be at the bottom. -->
	<div class="d-flex flex-row align-items-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div class="d-flex flex-row-reverse align-items-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Align Items Center</h3>
	<!-- align-items-center allows us to align our flex-row and flex-row-reverse items vertically. -->
	<div class="d-flex flex-row align-items-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div class="d-flex flex-row-reverse align-items-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h2 class="text-center my-5">Aligning Items Horizontally and Vertically</h2>
	<div class="d-flex flex-row align-items-end justify-content-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div class="d-flex flex-row align-items-end justify-content-around bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div class="d-flex flex-row align-items-center justify-content-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Mini-Activity with Flex Row</h3>
	<div class="d-flex flex-row justify-content-center align-items-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div class="d-flex flex-row align-items-center justify-content-between bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h2 class="text-center my-5">Flex Column with Align Items and Justify Content</h2>
	<!-- 
		For flex-row and flex-row-reverse, align-items aligns our flex-row and flex-row-reverse vertically, justify-content aligns our flex-row and flex-row-reverse horizontally.

		For flex-column and flex-column-reverse, align-items aligns our flex-column and flex-column-reverse horizontally, justify-content aligns our flex-column and flex-column-reverse vertically.

	 -->
	<div class="d-flex flex-column align-items-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
	</div>

	<div class="d-flex flex-column justify-content-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
	</div>

	<h3 class="text-center">Mini-Activity with Flex Column</h3>
	<div class="d-flex flex-column justify-content-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
	</div>

	<div class="d-flex flex-column align-items-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Flex Column with Justify Content Between and Around</h3>
	<div class="d-flex flex-column justify-content-between bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
	</div>

	<div class="d-flex flex-column justify-content-around bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Flex Wrap</h3>
	<div class="d-flex flex-row justify-content-around flex-wrap bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<div style="margin-top:500px;"></div>
	<!-- Javascript -->
	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
</body>
</html>